//variable definitions
var url = "https://e621.net/post/index.json?client_agent=e621MDL (jtvjan)"
var fullPostList = []
var URLWithLastID = url
var tags = ""
var imageID = 0
var containerID = 0

//function definitions
function showPosts() {
  $.each(postList, function(index, value) {
    var localImageID = imageID
    $("#images-container").append("<div id=\"container" + imageID + "\" class=\"image-container\"><img src=\"" + value.preview_url + "\" id=\"image" + imageID + "\"/></div>");
    $("#container" + imageID).click(function() {
      showFullContainer(localImageID)
    })
    $("#container" + imageID).css("width", value.preview_width);
    $("#container" + imageID).css("height", value.preview_height);
    imageID++
  });
  $('#images-container').freetile({
    selector: 'div',
    animate: false,
    callback: function() {
      $("#images-container").removeClass("zero-opacity");
    }
  });
}

function getPosts(s) {
  $.ajax({
    url: s,
    dataType: "jsonp",
    success: function(data) {
      postList = data
      fullPostList = fullPostList.concat(postList);
      $("body").removeClass("backgroundblink");
      showPosts();
      $("button").removeClass("hidden");
      $(".mdl-spinner").addClass("hidden");
    }
  });
}

function clearPosts() {
  imageID = 0
  fullPostList = []
  $("#images-container").addClass("zero-opacity");
  setTimeout(function() {
    $("#images-container").html("");
    $("body").addClass("backgroundblink");
  }, 500);
}

function morePosts(callback) {
  URLWithLastID = url + "&before_id=" + $(fullPostList).last()[0].id + "&tags=" + tags
  getPosts(URLWithLastID);
  $("button").addClass("hidden");
  $(".mdl-spinner").removeClass("hidden");
  if (typeof callback == "function") {
    callback();
  }
}

function showFullContainer(id) {
  containerID = id
  $("header").addClass("hidden");
  $("#full-image-container").removeClass("hidden");
  $("#full-image-container").css("background-image", "url(" + fullPostList[id].file_url + ")");
  $("#info").prop("href", "https://e621.net/post/show/" + fullPostList[id].id);
}

function hideFullContainer() {
  $("#full-image-container").addClass("hidden");
  $("header").removeClass("hidden");
}

//init
$(function() {
	//getting inital post list
	getPosts(url);
	//binding the load-more button
	$("#load-more").click(morePosts);
	//binding the back button in the full image container
	$("#back").click(hideFullContainer);
	//binding the title
	$(".mdl-layout-title").click(function() {
			clearPosts();
			getPosts(url);
		})
		//binding enter in search box
	$('input').keypress(function(e) {
		if (e.which == 13) {
			clearPosts();
			tags = $("input").val();
			URLWithTags = url + "&tags=" + tags
			getPosts(URLWithTags);
			return false;
		}
	});
	$(document).keydown(function(e) {
		if (!$('#full-image-container').hasClass("hidden")) {
			if (e.which == 37) {
				var nextContainerID = containerID - 1
				if (nextContainerID > 0) {
					containerID = nextContainerID
					$("#full-image-container").css("background-image", "url(" + fullPostList[nextContainerID].file_url + ")");
					$("#info").prop("href", "https://e621.net/post/show/" + fullPostList[nextContainerID].id);
				}
				return false;
			} else if (e.which == 39) {
				var nextContainerID = containerID + 1
				if (fullPostList.length > nextContainerID) {
					containerID = nextContainerID
					$("#full-image-container").css("background-image", "url(" + fullPostList[nextContainerID].file_url + ")");
					$("#info").prop("href", "https://e621.net/post/show/" + fullPostList[nextContainerID].id);
				} else {
					morePosts(function() {
            if (fullPostList.length > nextContainerID) {
              containerID = nextContainerID
              $("#full-image-container").css("background-image", "url(" + fullPostList[nextContainerID].file_url + ")");
              $("#info").prop("href", "https://e621.net/post/show/" + fullPostList[nextContainerID].id);
            }
          });
				}
				return false;
			} else if (e.which == 27) {
				hideFullContainer();
				return false;
			}
		}
	});
});
